<div class="container">
    <div class="columns is-multiline">
        <div class="column is-3">
            <!--File Input-->
            <div class="file has-name is-boxed is-primary is-justify-content-center">
                <label class="file-label">
                    <input class="file-input carga-csv" type="file" name="resume" accept="csv">
                    <span class="file-cta">
                        <span class="file-icon">
                            <ion-icon name="document-outline"></ion-icon>
                        </span>
                        <span class="file-label">
                            Seleccionar Archivo
                        </span>
                    </span>
                    <span class="file-name">
                    </span>
                </label>
            </div>
            <!--Button Guarda-->
            <div class="field mt-5">
                <div class="control has-text-centered">
                    <button class="button is-primary boton-guarda is-disabled" id="btn-guardar">
                        <span class="icon">
                            <ion-icon name="cloud-upload-outline"></ion-icon>
                        </span>
                        <span>Guardar</span>
                    </button>
                </div>
            </div>
        </div>
        <div class="column is-9">
            <div class="card">
                <div class="card-header">
                    <p class="card-header-title file-tags"></p>
                </div>
                <div class="card-content">
                    <div class="content is-flex is-flex-direction-column cargar-content-show" id="contentReader">
                    </div>
                </div>
            </div>
        </div>
        <div class="column is-12">
            <!-- Card datos -->
            <div class="card card-info is-hidden">
                <div class="card-header">
                    <div class="card-header-title"></div>
                </div>
                <div class="card-content">
                </div>
            </div>
        </div>
    </div>
</div>

<script type="module">
    // Import the functions you need from the SDKs you need
    import { initializeApp } from "https://www.gstatic.com/firebasejs/9.23.0/firebase-app.js";
    // TODO: Add SDKs for Firebase products that you want to use
    // https://firebase.google.com/docs/web/setup#available-libraries

    // Your web app's Firebase configuration
    const firebaseConfig = {
        apiKey: "AIzaSyC-bZu5_F00-Fmf4L6JgPF0wk4v8VjkoN4",
        authDomain: "testrealdb-17286.firebaseapp.com",
        projectId: "testrealdb-17286",
        storageBucket: "testrealdb-17286.appspot.com",
        messagingSenderId: "974668284905",
        appId: "1:974668284905:web:4b352bdf6f22d3b01c0178"
    };

    // Initialize Firebase
    const app = initializeApp(firebaseConfig);

    import { getDatabase, ref, set, get, update, remove, child, query } from "https://www.gstatic.com/firebasejs/9.23.0/firebase-database.js";

    // Get a reference to the database service
    const db = getDatabase();

    // documento on ready
    $(function() {
        // Carga CSV Archivo 
        $('.carga-csv').on('change',function() {
            loadCSVFileCheck($(this));
        });

        cargaLocationsAvailable();
        
        // Guarda los datos en la base de datos
        $('#btn-guardar').on('click', function(e) {
            let content = exportObject.data;
            content = content.filter(val => val)
            let header = content.shift();
            let result = [];
            // Recorre el array de datos y agreaga los headers a los values
            content.forEach(function(values) {
                let obj = {};
                for(let i = 0; i < header.length; i++) {
                    obj[header[i]] = values[i];
                }
                result.push(obj);
            });
            // Remueve los valores vacios
            removeEmptyValues(result).then(function(result) {
                //console.log(result);
                // Guarda en firebase
                const dbRef = ref(db, jsonName);
                set(dbRef, result).then(() => {
                    $('.file-name').html('');
                    $('.boton-guarda').addClass('is-disabled');
                    $('#contentReader').html('')
                    toast('Registrados','success');
                }).catch((error) => {
                    toast(error,'danger');
                    console.error(error);
                });
            }).catch(function(error) {
                console.log(error);
            });
            
        })
        
        // Inicializa el result como array y el fileName
        let exportObject = undefined;
        let jsonName = '';

        // Revisa el archivo CSV y lo carga en el DOM
        function loadCSVFileCheck(fileInput) {
            jsonName = '';
            let fileName = fileInput.val();
            let extension = fileName.split('.').pop().toLowerCase();
            let names = {
                'TOTL':'<span class="tag m-1 is-danger">Todas las Edades</span>',
                'Metadata':'<span class="tag m-1 is-warning">MetaDatos</span>',
                'TO_':'<span class="tag m-1 is-danger">Poblacion Total</span>',
                '0014':'<span class="tag m-1 is-info">edad 0 a 14</span>',
                '1564':'<span class="tag m-1 is-info">edad 15 a 64</span>',
                '65UP':'<span class="tag m-1 is-info">edad 65 y m&aacute;s</span>',
                'FE':'<span class="tag m-1 is-success">Femenina</span>',
                'MA':'<span class="tag m-1 is-success">Masculina</span>',
                'IN':'<span class="tag m-1 is-warning">Ingresos</span>'
            };
            let cabeceraTexto = 'Basado en el titulo parece contener:';
            $.each(names, function(index, value) {
                if (fileName.indexOf(index) != -1) {
                    cabeceraTexto += value;
                    jsonName += '_' + index;
                }
            })
            $('.file-tags').html(cabeceraTexto)

            if(extension != 'csv') {
                toast('Solo CSV','danger');
                $('.file-name').html('<span class="has-text-weight-bold has-text-danger">Archivo no v&aacute;lido<span>');
                $('.boton-guarda').addClass('is-disabled');
                $('#contentReader').html('')
            } else {
                toast('Si es CSV');
                $('.file-name').html('<span class="has-text-weight-bold has-text-success">' + fileName + '</span>');
                $('.boton-guarda').removeClass('is-disabled');
                $('#contentReader').html('');
                // Carga el archivo CSV en JsonFormat
                loadCSVFileDOM();
            }
        }

        // Carga el CSV en el DOM y los conveirte en JSON
        function loadCSVFileDOM(e) {
            let file = $('.carga-csv').prop('files')[0];
            let txt = ''
            Papa.parse(file, {
                complete: function(results) {
                    // Guarda los resultados en el array exportObject
                    exportObject = results
                    $.each(exportObject.data, function(index, value) {
                        // Creamos el texto a mostrar
                        txt += '<p class="is-size-7 paraIndex-' + index + '">';
                            txt += '<span class="icon has-text-danger-dark is-clickable borra-registro" data-id="' + index + '"><ion-icon name="remove-circle"></ion-icon></span>';
                        $.each(value, function(key, item) {
                            txt += '<span>' + item + ', </span>'
                        })
                        txt += '</p>'
                    })
                    // parse json to string
                    //jsonResults = JSON.stringify(results, null, "\t");
                    // Cambiamos el tema del div
                    $('.cargar-content-show').css('height', '250px');
                    $('#contentReader').html(txt);

                    $('.borra-registro').on('click', function(e) {
                        let id = $(this).data('id');
                        // Crea un modal para confirmar el borrado
                        let mTxt = '<div class="card-header has-text-centered">';
                            mTxt += '<span class="card-header-title">Quieres borrar el registro ' + id + '?</span>'
                        mTxt += '</div>';
                        mTxt += '<div class="card-content has-text-centered">';
                            mTxt += '<button class="button is-danger" id="borrarRegistro">Borrar!</button>';
                        mTxt += '</div>';
                        modal(mTxt);
                        // Si se confirma el borrado
                        $('#borrarRegistro').on('click', function(e) {
                            if (delete exportObject.data[id]) {
                                toast('Registro borrado', 'success');
                                $('.paraIndex-' + id).remove();
                            } else {
                                toast('No se pudo borrar el registro', 'danger');
                                return false;
                            }
                            modax();
                            //console.log(exportObject.data);
                        })
                    })
                }
            })
        }

        // Remueve los datos vacios del objeto
        function removeEmptyValues(obj) {
            // Return a Promise to allow asynchronous processing
            return new Promise(function(resolve, reject) {
                // Get the keys of the object
                let keys = Object.keys(obj);
                // Loop through the keys
                keys.forEach(function(key) {
                // If the value is an object, recursively call the function
                if (typeof obj[key] === 'object') {
                    removeEmptyValues(obj[key]).then(function(result) {
                    obj[key] = result;
                    });
                // If the value is an empty string, delete the key
                } else if (obj[key] === '') {
                    delete obj[key];
                }
                });
                // Resolve the Promise with the modified object
                resolve(obj);
            });
        }


        // Carga los libros disponibles
        function cargaLocationsAvailable(e) {
            isloading(1);
            get(ref(db)).then((snapshot) => {
                if (snapshot.exists()) {
                    const data = snapshot.val();
                    const locations = Object.keys(data);
                    // Muestra la card-info
                    $('.card-info').removeClass('is-hidden');
                    // Cambia el title
                    $('.card-info .card-header-title').html('Registros Disponibles: ' + locations.length);
                    let template = '<ul>';
                    $.each(locations, function(key, value) {
                        // Alimentala con los nombres de las locations
                        template += '<li style="display: flex; align-items: center; border-bottom: 1px dotted">';
                            template += `<ion-icon class="mr-3 is-clickable delete-info" name="trash" data-id='${key}' data-text='${value}'></ion-icon>`;
                            template += `<span class="mr-3 is-size-7">${value}</span>`;
                            template += `<ion-icon class="is-clickable show-info" name="add-circle" data-id='${key}' data-text='${value}'></ion-icon>`;
                        template += '</li>';
                    })
                    $('.card-info .card-content').html(template);
                    // Borra informacion del dataset de firebase y del DOM
                    $('.delete-info').on('click', function(e) {
                        let id = $(this).data('id');
                        let text = $(this).data('text');
                        // Crea un modal para confirmar el borrado
                        let mTxt = '<div class="card-header has-text-centered">';
                            mTxt += '<span class="card-header-title">Quieres borrar el registro ' + text + '?</span>'
                        mTxt += '</div>';
                        mTxt += '<div class="card-content has-text-centered">';
                            mTxt += '<button class="button is-danger" id="borrarRegistro">Borrar?</button>';
                        mTxt += '</div>';
                        modal(mTxt);
                        // Si se confirma el borrado
                        $('#borrarRegistro').on('click', function(e) {
                            remove(query(ref(db, text))).then(() => {
                                cargaLocationsAvailable();
                                modax();
                            }).catch((error) => {
                                console.error(error);
                            });
                        })
                    })
                    // Muestra la informacion del dataset
                    $('.show-info').on('click', function(e) {
                        let id = $(this).data('id');
                        let text = $(this).data('text');
                        // Template for div card class
                        let template = '<div class="card-header has-text-centered">';
                            template += '<span class="card-header-title">Informacion del dataset ' + text + '</span>';
                        template += '</div>';
                        template += '<div class="card-content">';
                        get(query(ref(db, text))).then((snapshot) => {
                            if (snapshot.exists()) {
                                const data = snapshot.val();
                                // Agrega input para filter data
                                template += '<div class="field">';
                                    template += '<div class="control is-small">';
                                        template += '<input class="input" type="text" placeholder="Filtrar datos" id="filterData">';
                                    template += '</div>';
                                template += '</div>';
                                template += '<div class="dataset-view">';
                                $.each(data, function(key, value) {
                                    template += `<ul><li><p class="has-text-weight-bold">${value['Country Name']} - <small>${value['Country Code']}</small></p></li></ul>`;
                                    template += '<ul>';
                                    $.each(value, function(k, v) {
                                        // Alimentala con los nombres de las locations
                                        template += '<li style="display: flex; align-items: center; border-bottom: 1px dotted">';
                                            template += `<span class="mr-3 is-size-7">${k}</span>`;
                                            template += `<span class="mr-3 is-size-7">${v}</span>`;
                                        template += '</li>';
                                    })
                                    template += '</ul>';
                                })
                                template += '</div>';
                                modal(template);
                                // Bind the keyup event to the input field
                                $('#filterData').on('keyup', function() {
                                    // Get the search string and convert it to lowercase
                                    const searchString = $(this).val().toLowerCase();
                                    // Use the filter() method to hide the li elements that don't match the search string
                                    $('ul li').filter(function() {
                                        return $(this).text().toLowerCase().indexOf(searchString) === -1;
                                    }).hide();
                                    // Show the li elements that match the search string
                                    $('ul li').filter(function() {
                                        return $(this).text().toLowerCase().indexOf(searchString) !== -1;
                                    }).show();
                                });
                                // Muestra la informacion del DOM con HR click
                                $('hr').on('click', function(e) {
                                    // show() child li
                                    $(this).next().toggle();
                                })
                            } else {
                                console.log("No data available");
                            }
                        }).catch((error) => {
                            console.error(error);
                        });
                    })
                } else {
                    console.log("No data available");
                }
                isloading(0);
            }, {
                onlyOnce: true
            }).catch((error) => {
                console.error(error);
            });
        }
    }());
</script>
